#ifndef ECL_H
#define ECL_H
#include <stdio.h>
struct ecl_file;
struct ecl_stanza;
struct ecl_caption;
struct ecl_file {
	char *name;
	struct ecl_stanza *head;

	FILE *src;

	char *line;
	int number;
};

struct ecl_stanza {
	char *name;
	struct ecl_stanza *next;
	struct ecl_caption *head;
};

struct ecl_caption {
	struct ecl_caption *next;
	char * name;
	char * value;
};
#ifdef ECL_C
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "miscfnc.h"
/* ecl.c */
static void ecl_stanza_free(struct ecl_stanza *s);
static void ecl_file_free(struct ecl_file *file);
static int ecl_file_get_line(struct ecl_file *file);
static void ecl_file_parse_line(struct ecl_file *file, struct ecl_stanza *stanza);
static void ecl_error(struct ecl_file *file, char *error_text);
static struct ecl_stanza *ecl_file_build_stanza(struct ecl_file *file);
static void ecl_file_add_stanza(struct ecl_file *file, struct ecl_stanza *stanza);
#endif
/* ecl.c */
struct ecl_file *ecl_file_open(char *name);
void ecl_file_close(struct ecl_file *file);
void ecl_file_init(struct ecl_file *file);
void ecl_show(struct ecl_file *file);
struct ecl_stanza *ecl_stanza_next(struct ecl_stanza *s);
struct ecl_stanza *ecl_file_find_stanza(struct ecl_file *file, char *name);
char *ecl_stanza_find_value(struct ecl_stanza *s, char *name);
void ecl_stanza_bool(struct ecl_stanza *s, char *name, int *place, int);
void ecl_stanza_string(struct ecl_stanza *s, char *name, char **place, char *);
void ecl_stanza_int(struct ecl_stanza *s, char *name, int *place, int);
#endif
