/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define BASE_C_
#define BASE_FRIEND_
#include "base.h"

//static struct man *mj;
static struct drawer *dj;
static struct item *ij;

static int caption_length(char *s)
{
	char *j = s;
	while (*j && *j != ',')
		j++;
	return j - s;
}

static char *return_caption(char *s)
{
	int len;
	char *ret = 0;
	if ((len = caption_length(s))) {
		ret = strncpy(xmalloc(sizeof(char) * (len+1)), s, len);
		ret[len] = 0;
	}
	return ret;
}

void put_item(struct drawer *d, char *caption)
{
	ij = xmalloc(sizeof(struct item));
	ij->next = 0;
	ij->caption = (caption) ? strdup(caption) : caption;

	if (!d->first)
		d->first = d->last = ij;
	else {
		d->last->next = ij;
		d->last = ij;
	}
}

static void add_drawer_extent(struct man *p, struct stanza *s, char *name, char *value)
{
	char *caption; 
	int len;
	struct item *i = NULL;
	
	if (p == NULL || value == NULL)
		return;

	if (s || p->unknown == NULL) {	
		dj = xmalloc(sizeof(struct drawer));
		dj->pattern = s;
	}

	if (s) {
		if (p->first == NULL)
			p->first = p->last = dj;
		else {
			p->last->next = dj;
			p->last = dj;
		}
		
	} else if (p->unknown == NULL) 
		p->unknown = dj;
		
	else {
		i = p->unknown->last;
		dj = p->unknown;
	}

		
	while (*value) 
		if ((caption = return_caption(value))) {
			len = strlen(caption);
			value += len;
			put_item(dj, caption);
			if (*value)
				value++;
		}
	
	if (s == NULL) {

		if (i)
			SWITCH(i);
		else
			i = p->unknown->first;

		for (; i; SWITCH(i)) {
			caption = strglue(name, " = ", i->caption);
			xfree(i->caption);
			i->caption = caption;
		}
	}
}

void add_drawer(struct man *p, struct stanza *s, char *value)
{
	add_drawer_extent(p, s, NULL, value);
}

void add_man(struct man *p) 
{
	if (p == NULL)
		return;

	if (first_man == NULL)
		first_man = last_man = current_man = p;
	else {
		last_man->next = p;
		last_man = p;
	}
}

static struct man *init_man(struct ecl_stanza *ecl_s)
{
	struct man *m = XALLOC(man);
	struct ecl_caption *ecl_c;

	for (ecl_c = ecl_s->head; ecl_c; SWITCH(ecl_c)) 
		add_drawer_extent(m, find_stanza_by_name(ecl_c->name),
			ecl_c->name, ecl_c->value);
	
	return m;
}

void add_new_man(void)
{
	add_man(XALLOC(man));
}

int read_base(char *name)
{
	struct ecl_file *file;
	struct ecl_stanza *ecl_s;
	
	struct man *m;

	if (name == NULL) 
		return 0;

	
	if ((file = ecl_file_open(name)) == NULL)
		return 0;

	ecl_file_init(file);			

	msgf("read in base file:         '%s'", name);

	for (ecl_s = file->head; ecl_s; SWITCH(ecl_s))
		if (ecl_s->head) {
			m = init_man(ecl_s);
			add_man(m);
		}

	ecl_file_close(file);

	return 1;
}
