/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define QUERY_C
#include "query.h"

char ** query_list;
static int query_len;
int query_counter;

int query_verify(char *pattern, struct drawer *d)
{
	struct item *i;
	char *name;


	for (; d; d = d->next)
		for (i = d->first; i; i = i->next) {
			name = strtolower(i->caption);
			if (strstr(name, pattern)) {
				xfree(name);
				return 1;
			}
			xfree(name);
		}

	return 0;
}

#define INC 10
void query(char *s, struct item *it)
{
	int l;

	if (s && *s)
		s = strglue("\t", "", s);
	else
		s = "";
	l = strlen(s);
	
	for (; it; it = it->next, query_counter++) {
		if (query_counter == query_len) {
			query_len += INC;
			query_list = xrealloc(query_list, 
					sizeof(char *) * (query_len+2));
		}
		query_list[query_counter] = xmalloc(sizeof(char)*
					(strlen(it->caption)+l+1));
		sprintf(query_list[query_counter],"%s%s", it->caption, s);
	}
	
	if (query_counter)
		query_list[query_counter] = NULL;

	if (l)
		xfree(s);
}

void query_free()
{
	while (query_counter) 
		xfree(query_list[query_counter--]);	
	
	xfree(query_list);

	query_list = NULL;
	query_counter = 0;
	query_len = 0;
}

