
#ifndef _TSYS_H
#define _TSYS_H
#include <stdlib.h>


#ifndef NULL
#define NULL (0L)
#endif

#define MIN(x,y) ((x>y)?(y):(x))
#define MAX(x,y) ((x>y)?(x):(y))
#define UNSIGNSUB(x,y) (((x)>(y))?((x)-(y)):0)

#include "tobj.h"
#include "archdep.h"
#include "tdisplay.h"
#include "miscfunc.h"
#include "tfamily.h"

struct tsys {
	struct tobj *rootwin;
	
	/* lock screen  - system doesn`t check what happen with objects
	 * just simply return key that were pressed */
	int lock;
	
	/* notify curses about whole screen redrawing */
	int force_refresh;
	
	int refresh;
	int sync;
	int garbage;
};
struct tevent {
	struct tobj *sender;
	struct tobj *address;
	long data;

	struct tevent *next;
};


/* Some standard events which maybe returned by tsystem */
/* 1000 - 1100 */
#define EVENT_QUIT (1000L)
#define EVENT_TERM_RESIZE (1001L)

/* Defined methods (1 - 50) */
#define TSYS_ACTIVATE_NEXT  (1L)
#define TSYS_LOCK_SCREEN    (12L)
#define TSYS_UNLOCK_SCREEN  (11L)
#define TSYS_FORCE_REFRESH  (13L)

/* Address types */
#define EVENT_TYPE_INTERNAL	(0)
#define EVENT_TYPE_USER		((struct tobj *)1)

extern struct tsys *tsystem;

struct tobj *tsys_init(void);
void tsys_free(void);
struct tevent *tsys_process(struct tobj *obj);
void tsys_checkrefresh( void );
void tsys_dorefresh(void);
int tsys_domethod(long method, long data);

void tsys_error(char *errormsg);
void tsys_error_exit(char *errormsg);

struct tevent *tevent_get(void);
void tevent_send(struct tobj *sender, struct tobj *address, long data);
void tevent_free(struct tevent *event);

#endif
