/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define WCHOICE_C_
#include "wchoice.h"

static struct tobj *win_choice, *cmenu_choice;

int wchoice_service(struct tevent *e)
{
	if (e->sender != cmenu_choice && e->sender != win_choice)
		return 0;
		
	switch (e->data) {
	case EVENT_TLIST_REJECT:
	case EVENT_TMENU_REJECT:
		edit_mode = 0;
		scr_refresh();
		return 1;
	}

	return 0;
}



void wchoice_show()
{
	tobj_show(win_choice);
}

void wchoice_hide()
{
	tobj_rhide(win_choice);
}

int wchoice_create(struct tobj *rootwin)
{
	DEFINE_SIZES(Wchoice);
	if (!(win_choice = twin_init(rootwin, x, y, w, h,
		translate("make up your mind"))))
		return 0;
	if (!mchoice_flush())
		return 0;
        tset(win_choice, TOBJ_HIDDEN, 1);
	
	return 1;
}

void wchoice_free(void)
{
	set_size(Wchoice, win_choice);	
	tobj_free(win_choice);
	win_choice = cmenu_choice = NULL;
}

void mchoice_add(char *s, notifyfnc fnc, long data)
{
	add_menuobj(cmenu_choice, s, fnc, data);
}


int mchoice_flush()
{
	int reinit = (cmenu_choice) ? 1 : 0;
	if (reinit)
		tobj_free(cmenu_choice);
	if (!(cmenu_choice = tcmenu_init(win_choice, 1, 1, 
		get_w(Wchoice)-2, get_h(Wchoice)-2, mtab))) {
		if (reinit)		
			errexit("Cannot reinit cmenu chice\n");
		return 0;
	}
	return 1;
}

long mchoice_len()
{
	long n;
	tget(cmenu_choice, TLIST_ACTIVE, &n);	
	return n;
}

char *mchoice_title()
{
	char *s = (char *)txget(cmenu_choice, TLIST_ACTIVE_STRING);
	return s;
}

