/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define WPEOPLE_C_
#include "wpeople.h"

struct tobj *cmenu_people, *win_people;

static void usecmd_m(struct tobj *obj, long data)
{
	struct drawer *dj = find_drawer_by_name(current_man, enter_cmd);
	
	(void)obj;
	(void)data;

	if (dj && dj->pattern->command) {
		export_allenv(current_man);
		setenv(dj->pattern->name, dj->first->caption, 1);
		currentdrawer_set(dj);
		muse_create_m(0, 0);
	}
}

int wpeople_service(struct tevent *e)
{
	if (e->sender != cmenu_people && e->sender != win_people && e->sender)
		return 0;

	switch (e->data) {
	case EVENT_TLIST_CHANGE:
		scrpeople_refresh();
		return 1;
	case EVENT_TLIST_REJECT:
	case EVENT_TMENU_REJECT:
		scrpeople_show();
		return 1;
	}
	return 0;
}
	
void mpeople_get(long m, long *data)
{
	tget(cmenu_people, m, data);
}

void mpeople_set(long m, long data)
{
	tset(cmenu_people, m, data);
}

void mpeople_domethod(long m, long data)
{
	tobj_domethod(cmenu_people, m, data);
}

int mpeople_additem(char *name)
{
	if (add_menuobj(cmenu_people, name, usecmd_m, 0))
		return 1;
	return 0;
}

void wpeople_show()
{
	tobj_show(win_people);
}

void wpeople_hide()
{
	tobj_rhide(win_people);
}

void wpeople_set(long m, long data)
{
	tset(win_people, m, data);
}

int mpeople_create()
{
	struct tcmenu_entry mtab[] = {{ TMENU_END , NULL , 0 }};
	struct man *jm;

	if (!(cmenu_people = tcmenu_init(win_people, 1, 1, 
		get_w(Wpeople)-2, get_h(Wpeople)-2, mtab)))
		return 0;

	for (jm = first_man; jm; jm = jm->next) 
		if (!mpeople_additem(return_menuname(jm)))
			return 0;
			
	return 1;
}

int wpeople_create(struct tobj *rootwin) 
{
	DEFINE_SIZES(Wpeople);
	if (!(win_people = twin_init(rootwin, x, y, w, h, translate("People"))))
		return 0;

	if (!mpeople_create())
		return 0;

	return 1;
}

void mpeople_free()
{
	tobj_free(cmenu_people);
	cmenu_people = NULL;
}

void wpeople_free()
{
	set_size(Wpeople, win_people);
	mpeople_free();
	tobj_free(win_people);
	win_people = NULL;
}
